import { Interceptors } from './interceptors';
import { ElMessage } from "element-plus";
export class HttpRequest {
  public axios: any
  constructor() {
    // 获取axios实例
    this.axios = new Interceptors().getInterceptors();
  }
  public get(url: string, params: String, config: Object = {}) {
    return new Promise((resolve, reject) => {
      let paramUrl = url
      if (params) {
        paramUrl += `?${params}`
      }
      this.axios.get(paramUrl, {
        ...config
      }).then((res: any) => {
        this.resultHandle(res, resolve, reject, url);
      }).catch((err: { message: any; }) => {
        console.log(err)
        reject(err.message);
      })
    })
  }

  public getjson(url: string, params: Object = {}, config: Object = {}) {
    return new Promise((resolve, reject) => {
      let paramUrl = url
      let paramStr = ''
      for (const [key, value] of Object.entries(params)) {
        if (value !== null && value !== undefined && value !== '') {
          paramStr += `${key}=${value}&`
        }
      }
      if (paramStr.length > 0) {
        paramUrl += `?${paramStr.substring(0, paramStr.length - 1)}`
      }
      this.axios.get(paramUrl, {
        ...config
      }).then((res: any) => {
        this.resultHandle(res, resolve, reject, url);
      }).catch((err: { message: any; }) => {
        reject(err.message);
      })
    })
  }
   public getjsontab(url: string, params: Object = {}, config: Object = {}) {
    return new Promise((resolve, reject) => {
      let paramUrl = url
      let paramStr = ''
      for (const [key, value] of Object.entries(params)) {
          paramStr += `${key}=${value}&`
      }
      if (paramStr.length > 0) {
        paramUrl += `?${paramStr.substring(0, paramStr.length - 1)}`
      }
      this.axios.get(paramUrl, {
        ...config
      }).then((res: any) => {
        this.resultHandle(res, resolve, reject, url);
      }).catch((err: { message: any; }) => {
        reject(err.message);
      })
    })
  }
  public getid(url: string, params: String, config: Object = {}) {
    return new Promise((resolve, reject) => {
      let paramUrl = url
      if (params) {
        paramUrl += `${params}`
      }
      this.axios.get(paramUrl, {
        ...config
      }).then((res: any) => {
        this.resultHandle(res, resolve, reject, url);
      }).catch((err: { message: any; }) => {
        reject(err.message);
      })
    })
  }

  public post(url: string, params: Object, config: Object = {}) {
    return new Promise((resolve, reject) => {
      this.axios.post(url, params, {
        ...config   //  导出添加的下载类型
      }).then((res: any) => {
        this.resultHandle(res, resolve, reject, url);
      }).catch((err: { message: any; }) => {
        reject(err.message);
      })
    })
  }

  public put(url: string, params: Object, config: Object = {}) {
    return new Promise((resolve, reject) => {
      this.axios.put(url, params, {
        ...config
      }).then((res: any) => {
        this.resultHandle(res, resolve, reject, url);
      }).catch((err: { message: any; }) => {
        reject(err.message);
      })
    })
  }

  public delete(url: string, params: Array<any>) {
    return new Promise((resolve, reject) => {
      let paramUrl = url + params.toString()
      this.axios.delete(paramUrl, {
      }).then((res: any) => {
        this.resultHandle(res, resolve, reject, url);
      }).catch((err: { message: any; }) => {
        reject(err.message);
      })
    })
  }

  /**
   *
   * @param url   请求路径
   * @param params  { method  //  封装的请求类型(getId,post,get...) , params{ fileName // 文件名 } // 请求参数   }
   * @returns
   */

  public exportfile(url: string, params: any) {
    console.log(JSON.parse(JSON.stringify(params)))
    return new Promise((resolve, reject) => {
      // @ts-ignore
      this[params.method](url,params.params,{responseType: "blob",}).then((res:any)=>{
        console.log(JSON.parse(JSON.stringify(res)))
        if(res.code == 500) return reject(res.message)
          let blob = new Blob([res], { type: "application/x-xlsx" });
          let url = URL.createObjectURL(blob);
          console.log(params)
          this.downloadFile(url, params.params.fileName);
          resolve('下载成功！')
      }).catch((err: { message: any; }) => {
        reject(err.message);
      })
    })
  }

  public exprotfl(url: String, params: Object) {
    return new Promise((resolve, reject) => {
      let paramUrl = url
      if (params) {
        paramUrl += `?${params}`
      }
      this.axios.get(paramUrl, {
        responseType: "blob",
      }).then((res: any) => {
        let blob = new Blob([res], { type: "application/x-xlsx" });
        let url = URL.createObjectURL(blob);
        this.downloadFile(url, '船舶信息数据.xlsx');
        this.resultHandle(res, resolve, reject, url);
      }).catch((err: { message: any; }) => {
        reject(err.message);
      })
    })
  }
  public examefl(url: String, params: Object,un:string,filName:string) {
    return new Promise((resolve, reject) => {
      let paramUrl = url
      if (params) {
        paramUrl += `?${params}`
      }
      this.axios.get(paramUrl, {
        responseType: "blob",
      }).then((res: any) => {
        let blob = new Blob([res], { type: "application/x-xlsx" });
        let url = URL.createObjectURL(blob);
        this.downloadFile(url, `${filName}.xlsx`);
        this.resultHandle(res, resolve, reject, url);
      }).catch((err: { message: any; }) => {
        reject(err.message);
      })
    })
  }

  public downloadFile(url: string, filename: string) {
    const a = document.createElement('a')
    a.href = url
    if (filename) a.download = filename
    a.click()
  }

  public resultHandle(res: any, resolve: { (value: unknown): void; (value: unknown): void; (arg0: any): void; },reject: { (value: unknown): void; (value: unknown): void; (arg0: any): void; }, url: string) {
    if (res) {
      if (res.code === 200 || (res.size > 0 && res.type)) {   //  增加blob文件判断
        resolve(res);
      } else {
        this.errorHandle(res, reject, url);
      }
    }
  }

  public errorHandle(res: any, reject: any, url: string) {
    console.error('错误接口：' + url)
    if (res.hasOwnProperty('message')) {
      ElMessage.warning(res.message);  // 统一谈服务端提示,我们提示统一由服务端提供
    } else if (res.hasOwnProperty('msg')) {
      ElMessage.warning(res.msg);  // 统一谈服务端提示,我们提示统一由服务端提供
    }
    // 状态码判断
    if (res) {
      switch (res.code) {
        case -102:
          break;
        case -152:
          break;
        default:
          reject(res);
      }
    }
  }

  public trackpost(url: string, params: object,filName:string) {
    return new Promise((resolve, reject) => {
      let paramUrl = url
      this.axios.post(paramUrl,params,{
        headers: { Authorization: localStorage.getItem('ax_token') },
        responseType: "blob",
      }).then((res: Blob) => {
        let blob = new Blob([res], { type: "application/x-xlsx" });
        let url = URL.createObjectURL(blob);
        this.downloadFile(url, `${filName}.xlsx`);
        resolve('')
      }).catch((err: { message: any; }) => {
        reject(err.message);
      })
    })
  }

}

export default HttpRequest
