

# CusContent 列表布局组件
props
~~~~
tableHead：CusTable的表头数据-用来加载字段筛选
showText：是否显示复合查询
text：复合查询文本输入框绑定变量
searchTip：复合查询默认提示placeholder
full：内容铺满
~~~~
emit
~~~~
handleReset：重置按钮回调方法
handleSearch：查询按钮回调方法
handleText(text)：复合查询文本输入值改变时回调方法
~~~~
slot
~~~~
top：顶部其他内容插槽
fieldOut：筛选条件插槽
center：筛选条件余表格中间其他内容插槽
buttons：左侧操作按钮插槽
fieldIn：高级筛选条件插槽
table：表格位置插槽
~~~~

# CusTable 表格组件
props
~~~~
tableData：表格数据
tableHead：表头数据 {
    value 必须：变量
    label 必须：名称
    show：是否默认显示
    sort：是否开启排序
    popover：是否可以悬浮提示（鼠标可以滑入复制）
    width：宽度
    align：对齐位置
    headerAlign：表头对齐位置
    filters：开启列排序时的数据

    多级表头时采用嵌套的方式，最多三级表头
    如 tableHead: [
        {
            label：父表头,
            children: [
                表头, 表头, 表头
            ]
        }
    ]
}
total：列表总数变量
page：列表当前页变量
pageSize：列表页大小变量
selected可不传：多选列表时绑定的数组变量，
noPage 开启即可隐藏分页组件
otherStyle：非通用列表时传true不加载样式
showIndex：展示序号列
singled: 单选绑定对象
singledKey: 单选唯一标识
:pageSizes="[1, 3, 5]" 页码大小
:noLayout="['sizes', 'total']"  分页不采用的布局标识
full：表格不出现滚动条，内容铺满
~~~~
emit
~~~~
handlePage({page, pageSize})：列表分页改变时回调方法
handleSort({key, value})：列表排序改变时回调方法
handleFilter({key, value})：列过滤改变时回调方法
~~~~
slot
~~~~
{列变量}-column：表格列默认使用CusTableColumn，如需自定义el-table-column，使用该插槽
{列变量}-column-value：表格列值需要翻译，样式修改等操作时，使用该插槽，如果还需悬浮提示的话，需要在内部嵌套CusPopover
~~~~
ref外部方法
~~~~
resetFilter(key)：清空列过滤状态，key列变量，不传则全部清空
~~~~

# CusPopover 悬浮提示组件
props
~~~~
value：提示的内容
~~~~
slot
~~~~
默认：触发内容
~~~~

# CusSearchButtons 查询按钮组
props
~~~~
expandValue：展开状态绑定的参数，不传则不显示展开按钮
~~~~
emit
~~~~
handleReset：重置按钮回调方法
handleSearch：查询按钮回调方法
~~~~

# CusForm 表单
props
~~~~
labelWidth：表单标题宽度，默认100px
~~~~
emit
~~~~
handleEnter：input文本域回车统一触发方法
submit：表单提交校验
~~~~


# CusFormColumn 表单细项
详见demo：/views/demo/form/*.vue
props
~~~~
span: el-col的布局
filterSpan: 列表采用5等分布局时的栅格，[1,2,3,4,5]对应n/5
offset: el-col的布局
link: input、cascader、checkbox、date、datetime、radio、select、switch、portOfRegistry(船籍港)、residentMooringPoint(常驻停泊点)、dept(部门树)
all：link为dept时，默认为当前部门及子部门，传值则为所有部门
param: 通用的参数
paramOne: 双下拉时第一级参数
paramTwo: 双下拉时第二级参数
label: 标题
required: 是否必填
labelWidth: 标题宽度
rules: 校验规则
maxLength: 长度校验值
minLength: 长度校验值
$attrs：elementPlus各属性
~~~~
emit
~~~~
handleValidate：触发校验
getDefault：link为dept时，默认获取的顶级部门
~~~~
