import { createApp } from 'vue'
import App from './App.vue'
import router from './router'
import store from "./store"
import ElementPlus from 'element-plus'
import 'element-plus/dist/index.css'
// @ts-ignore
import './styles/index.scss'
import './browerPatch'
import 'virtual:svg-icons-register'    // 【svg-icons相关】
import initComponent from '@/plugins/initComponent'
import initProperties from '@/plugins/initProperties'
import repeatFileValid from '@/plugins/repeatFileValid'
import initDirect from '@/plugins/initDirect'
repeatFileValid()
const app = createApp(App)
await initProperties(app)
initComponent(app)
app.use(initDirect)
app.use(router)
app.use(store)
app.use(ElementPlus)
app.mount('#app')
