import { RouteRecordRaw, createRouter, createWebHistory } from 'vue-router'
import shipTestRouter from "./ship-test";
const routes = [
    {
        path: '/',
        component: () => import('@/views/index.vue'),
    },
    {
        path: '/mock-track',
        component: () => import('@/views/init-speed-track/index.vue'),
    },
    {
        path: '/track-status',
        component: () => import('@/views/track-status/index.vue'),
    },
    {
        path: '/auth',
        name: 'auth',
        component: () => import('@/views/auth.vue')
    },
    ...shipTestRouter
]

const router = createRouter({
  history: createWebHistory(),
  routes,
});

export default router;
